//
//                                                                        
//  ARCMSG.H                                                              
//                                                                        
//  AESOP Resource Compiler language-specific definitions                 
//                                                                        
//  Version: 1.00 of 26-Feb-92 -- Initial version                         
//                                                                        
//  Project: Extensible State-Object Processor (AESOP/16)                 
//   Author: John Miles                                                   
//                                                                        
//  C source compatible with IBM PC ANSI C/C++ implementations            
//  Large memory model (16-bit DOS)                                       
//                                                                        
//
//                                                                        
//  Copyright (C) 1992 Miles Design, Inc.                                 
//                                                                        
//  Miles Design, Inc.                                                    
//  10926 Jollyville #308                                                 
//  Austin, TX 78759                                                      
//  (512) 345-2642 / BBS (512) 454-9990                                   
//                                                                        
//

#define MSG_BANNER "AESOP/16 Resource Compiler V%s\n\
Copyright (C) 1992, 1993 Miles Design, Inc.  All rights reserved.\n"

#define MSG_SYN_1    "Usage: ARC [options] script_file (* = default)\n"
#define MSG_SYN_2    "\n"
#define MSG_SYN_3    "/cnnn   Resource file compaction threshold = nnn%% (default=25%%)\n"
#define MSG_SYN_4    "/dx[=y] Define macro x=y\n"
#define MSG_SYN_5    "/kp     Do not delete preprocessor output files\n"
#define MSG_SYN_6    "/n      Force creation of new resource file\n"
#define MSG_SYN_7    "/oxxx   Output resource filename = xxx\n"
#define MSG_SYN_8    "/v      Verbose compilation\n"
#define MSG_SYN_9    "/sb     Show brief resource file dump\n"
#define MSG_SYN_10   "/sv     Show verbose resource file dump\n"
#define MSG_SYN_11   "/w0   * Show notice, warning, and error messages\n"
#define MSG_SYN_12   "/w1     Show warning and error messages only\n"
#define MSG_SYN_13   "/w2     Show error messages only\n"
#define MSG_SYN_14   "/x      Do not verify unique resource names\n"

#define MN_CREATE    "create"
#define MN_DESTROY   "destroy"
#define MN_RESTORE   "restore"

#define KW_ATTRIB    "attrib"
#define KW_SEQUENCE  "sequence"
#define KW_SAMPLE    "sample"
#define KW_STRING    "string"
#define KW_SOURCE    "source"
#define KW_DOCUMENT  "document"
#define KW_MAP       "map"
#define KW_PALETTE   "palette"
#define KW_FILE      "file"
#define KW_CODE      "code_resources"
#define KW_FIXED     "fixed"
#define KW_MOVEABLE  "moveable"
#define KW_PRECIOUS  "precious"
#define KW_DISCARD   "discardable"
#define KW_TEMPORARY "temporary"

#define KW_THIS      "this"
#define KW_CASE      "case"
#define KW_DEFAULT   "default"
#define KW_MESSAGE   "message"
#define KW_PROCEDURE "procedure"
#define KW_RETURN    "return"
#define KW_IF        "if"
#define KW_ELSE      "else"
#define KW_SWITCH    "switch"
#define KW_WHILE     "while"
#define KW_DO        "do"
#define KW_FOR       "for"
#define KW_LOOP      "loop"
#define KW_BREAK     "break"
#define KW_CONTINUE  "continue"
#define KW_CLASS     "class"
#define KW_MEMBER    "member"
#define KW_EXTERN    "extern"
#define KW_PUBLIC    "public"
#define KW_PRIVATE   "private"
#define KW_TABLE     "table"
#define KW_LONG      "long"
#define KW_WORD      "word"
#define KW_BYTE      "byte"
#define KW_AND       "and"
#define KW_OR        "or"
#define KW_NOT       "not"
#define KW_STRING    "string"
#define KW_TRIGGER   "trigger"

#define FN_SEND      "send_message"
#define FN_PASS      "pass_message"

#define PD_DEFINE    "define"
#define PD_UNDEF     "undef"
#define PD_INCLUDE   "include"
#define PD_DEPEND    "depend"
#define PD_IFDEF     "ifdef"
#define PD_IFNDEF    "ifndef"
#define PD_ELSE      "else"
#define PD_ENDIF     "endif"
#define PD_VERBOSE   "verbose"
#define PD_BRIEF     "brief"

#define MSG_NOTICE   "Notice"
#define MSG_WARNING  "Warning"
#define MSG_ERROR    "Error"
#define MSG_FATAL    "Fatal error"
#define MSG_FAULT    "Internal error"

#define MSG_IOERR    "I/O error accessing file '%s'"
#define MSG_OOM      "Insufficient free memory"
#define MSG_FNF      "Can't find file '%s'"
#define MSG_CWF      "Can't write file '%s'"
#define MSG_CRF      "Can't read from file '%s'"
#define MSG_DFULL    "Disk full"
#define MSG_LTOOL    "Maximum input line length exceeded"

#define MSG_COT      "Can't open temporary file '%s'"
#define MSG_UOI      "Unable to open include file '%s'"
#define MSG_UBC      "Unbalanced '*/' comment terminator"
#define MSG_UBB      "Unbalanced ']' text literal terminator"
#define MSG_CCL      "Can't concatenate line at end of file"
#define MSG_UCC      "Unterminated literal or character constant"
#define MSG_UPD      "Skipping unknown preprocessor directive '%s'"
#define MSG_RDF      "Replacing previous definition of macro '%s'"
#define MSG_MND      "Macro '%s' not previously defined"
#define MSG_CCF      "Can't concatenate identifier name fragments"
#define MSG_MPD      "Misplaced preprocessor directive"
#define MSG_CCE      "Escape code outside literal or character constant"
#define MSG_UPE      "Unexpected #else directive"
#define MSG_UPI      "Unexpected #endif directive"
#define MSG_NTD      "Preprocessor conditionals nested too deeply"
#define MSG_MIA      "Missing or invalid directive argument"
#define MSG_MIF      "Missing or invalid filename"
#define MSG_UEF      "Conditional preprocessor directive open at end of file"
#define MSG_OCO      "Comment block open at end of file"
#define MSG_OLL      "Output line too long"

#define MSG_CNR      "Creating new resource file '%s'"
#define MSG_CMR      "Compacting resource file '%s'"
#define MSG_CWR      "Can't create resource file '%s'"
#define MSG_OBF      "Invalid or obsolete resource file '%s'"
#define MSG_BRE      "Resource file entry %lu invalid"
#define MSG_RCR      "Can't read from file"
#define MSG_RCW      "Can't write to file -- disk may be full"

#define MSG_BCM      "Bad command-line macro definition"
#define MSG_ICO      "Invalid command-line option; use /? for help"
#define MSG_NFS      "No resource script to compile"
#define MSG_IVC      "Invalid constant"
#define MSG_UTD      "Resource file '%s' is already up to date"

#define MSG_MAS      "Missing attribute specifier"
#define MSG_MSC      "Missing constant or string literal"
#define MSG_RAT      "Redundant attribute specifier"
#define MSG_CAT      "Contradictory attribute specification"
#define MSG_MTT      "'%s' attribute meaningless when 'temporary' specified"
#define MSG_MAT      "'temporary' attribute meaningless when used with others"
#define MSG_SYN      "Syntax error ('%s')"
#define MSG_EXP      "Expected '%s', found '%s'"
#define MSG_ERS      "Expected resource type specifier"
#define MSG_MDT      "All code resources must be defined together"
#define MSG_RWU      "Reserved word '%s' used as identifier"
#define MSG_CAD      "Code resource '%s' already defined"
#define MSG_CMI      "Code resource name must be valid C identifier"
#define MSG_SNF      "File '%s' not found"
#define MSG_MRS      "Incomplete resource specification"
#define MSG_TMR      "Too many resource parameters specified"
#define MSG_NIU      "Resource name '%s' already in use"
#define MSG_LVR      "Can't assign or modify non-variable expression"
#define MSG_EPE      "Missing or invalid expression"
#define MSG_UID      "Unknown identifier '%s'"
#define MSG_EDS      "Expected class or object definition statement"
#define MSG_NML      "Name of class or object must be enclosed in \"\" quotes"
#define MSG_UEO      "Unexpected end of file"
#define MSG_BFT      "Unrecognized source file format"
#define MSG_ICU      "Name '%s' already in use as code resource identifier"
#define MSG_VIU      "Variable '%s' already defined"
#define MSG_TML      "Too many nested control structures"
#define MSG_GBC      "'break' or 'continue' outside of control structure"
#define MSG_ELC      "Expected literal constant, found '%s'"
#define MSG_ELS      "Expected string literal, found '%s'"
#define MSG_OSW      "'%s' outside of switch statement"
#define MSG_RDC      "Duplicate case value '%s'"
#define MSG_ASX      "Maximum array size (64K) exceeded"
#define MSG_TMD      "'%s' has too many array dimensions"
#define MSG_NED      "Variable '%s' requires one or more additional dimensions"
#define MSG_TMM      "Too many message names defined"
#define MSG_PMR      "Resource '%s' has not yet been compiled"
#define MSG_BMN      "Message name '%s' must be string literal"
#define MSG_BPN      "Bad procedure name '%s'"
#define MSG_RMN      "Handler for message '%s' has already been defined"
#define MSG_RPN      "Procedure '%s' has already been defined"
#define MSG_URC      "Code outside procedure or message handler is unreachable"
#define MSG_CND      "Cannot nest procedure or message handler definitions"
#define MSG_AVO      "Auto variable declaration outside procedure or message handler"
#define MSG_IUB      "Inappropriate use of array indexing"
#define MSG_IUA      "Inappropriate use of parentheses"
#define MSG_IUD      "Inappropriate use of dot operator"
#define MSG_NMI      "Object may inherit from only one class"
#define MSG_BCN      "Class specifiers may be used only with extern variables"
#define MSG_NCL      "External reference needs object handle"
#define MSG_MCS      "External variable declaration '%s' needs class specifier"
#define MSG_CIA      "Only table arrays may be initialized"
#define MSG_TIN      "Table '%s' requires %lu initializers (%lu present)"
#define MSG_OCS      "Out of code space"
#define MSG_CMT      "Illegal attempt to modify table '%s'"
#define MSG_DNU      "Variable '%s' declared but never used"
#define MSG_VNU      "Value assigned to variable '%s' is never used"
#define MSG_PPU      "Possible use of variable '%s' before assignment"
#define MSG_BPT      "Table declaration inside procedure or message handler"
#define MSG_IVA      "Variable '%s' cannot be modified directly"
#define MSG_NBC      "Binary constant '%s' has %lu digits"

#define MSG_HER      "Heap unbalanced or corrupted (%lu init)"

#define MSG_RS_FIL   "     File: %s\n"
#define MSG_RS_FOR   "   Format: %s\n"
#define MSG_RS_SIZ   "     Size: %lu bytes\n"
#define MSG_RS_NEN   "# entries: %lu\n"
#define MSG_RS_USE   "   In use: %lu bytes (%lu%% fragmented)\n"
#define MSG_RS_CTS   "  Created: %s\n"
#define MSG_RS_MTS   " Modified: %s\n"

#define MSG_RS_FIX   "F"
#define MSG_RS_MOV   "M"
#define MSG_RS_PRE   "P"
#define MSG_RS_DIS   "D"
#define MSG_RS_TMP   "T"

#define MSG_RS_BRI   "%.07lu @ %.07lu: %s %s (%.07lu)\n"
#define MSG_RS_VER   "%.07lu @ %.07lu: %s %s (%.07lu) %s %s\n"
#define MSG_RS_PLA   "%.07lu @ %.07lu: (PLACEHOLDER) %s %s\n"
#define MSG_RS_DEL   "%.07lu: (DELETED)\n"
#define MSG_RS_INV   "DICTIONARY"

#define MSG_NON      "None"

#define MSG_CP_SML   "    Lines compiled: %lu\n"
#define MSG_CP_RCO   "Resources compiled: %lu\n"
#define MSG_CP_RCC   "   Resources added: %lu\n"
#define MSG_CP_SME   "    Error messages: %s\n"
#define MSG_CP_SMW   "  Warning messages: %s\n"
#define MSG_CP_MEM   "  Remaining memory: %luk\n"
